"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
const mqtt = require("mqtt");
const rxjs_1 = require("rxjs");
class Mqtt {
    constructor(config) {
        const { topics } = config, opts = __rest(config, ["topics"]);
        this.client = mqtt.connect(opts);
        this.client.subscribe(topics);
        // TODO: Fix these cases and handle them in test coverage
        this.client.on('connect', e => {
            console.log('connect');
        });
        this.client.on('error', e => {
            console.error(e);
        });
        this.client.on('close', e => {
            console.log('close');
        });
        this.client.on('offline', e => {
            console.log('offline');
        });
        this.client.on('reconnect', e => {
            console.log('reconnect');
        });
    }
    create() {
        return rxjs_1.Observable.fromEvent(this.client, 'message', (topic, payload) => ({
            topic,
            payload
        })).map(({ topic, payload }) => {
            // TODO: Pipe buffer payload into a more performant JSON parser
            let parsedPayload = payload.toString();
            try {
                parsedPayload = JSON.parse(parsedPayload);
            }
            catch (e) { }
            return { topic, payload: parsedPayload };
        });
    }
}
module.exports = Mqtt;
//# sourceMappingURL=index.js.map